<?xml version="1.0" encoding="UTF-8"?>

<!--
    Document   : loadVereine.xsl
    Created on : 6. September 2013, 10:35
    Author     : me-apps
    Description:
        Erzeugt SQL Befehle zum Füllen der team Tabelle.
-->


<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="text"/>

    <xsl:template match="text()"/>
  
  
    <xsl:template match="Spiel">
        <xsl:text>INSERT OR REPLACE INTO spiele (spielId,nummer,heimId,heim,gastId,gast,datum,startZeit,zeit,geschlecht,verband,staffel,staffelKurz,halle, harzregel, pinCheckHeim,pinCheckGast,encryptedHeim,encryptedGast,</xsl:text>
        <xsl:text>spielberichtJSON,timeoutHeim, timeoutGast, dauerHalbzeit, dauerTimeout, dauerHinausstellung, anzahlTimeOut, anzahlSpieler, buzzerNachTimeout, buzzerAmEnde, pokal,sz_datum) values (</xsl:text>
        <xsl:value-of select="@ID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="@Nummer"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="@HeimID"/>
        <xsl:text>,"</xsl:text>
        <xsl:value-of select="@HeimLang"/>
        <xsl:text>",</xsl:text>
        <xsl:value-of select="@GastID"/>
        <xsl:text>,"</xsl:text>
        <xsl:value-of select="@GastLang"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Datum"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Zeit"/>
        <xsl:text>",0,"</xsl:text>
        <xsl:value-of select="@Geschlecht"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Organisationlang"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Staffellangname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Staffelkurzname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Hallenname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Harzreglung"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="Mannschaft[@teamType='Heim']/@pinCheck"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="Mannschaft[@teamType='Gast']/@pinCheck"/>
        <xsl:text>",</xsl:text>
        <xsl:choose>
            <xsl:when test="@Mannschaft[@teamType='Heim']/@pinCheck = ''">0</xsl:when>
            <xsl:otherwise>1</xsl:otherwise>
        </xsl:choose>
        <xsl:text>,</xsl:text>
        <xsl:choose>
            <xsl:when test="@Mannschaft[@teamType='Gast']/@pinCheck = ''">0</xsl:when>
            <xsl:otherwise>1</xsl:otherwise>
        </xsl:choose>
        <xsl:text>,null,0,0,</xsl:text>
        <xsl:value-of select="@Spielzeit"/>
        <xsl:text>*60,50,120,</xsl:text>
        <xsl:value-of select="@AnzahlTeamTimeouts"/>
        <xsl:text>,14,0,0,</xsl:text>
        <xsl:choose>
            <xsl:when test="@Pokal = 1">1</xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
        <xsl:text>,"");</xsl:text>
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="Person[number(@TrikotNummer) != number(@TrikotNummer)]">
        <!--<xsl:text>INSERT OR REPLACE INTO offizielle (spielnummer, bezeichner, gast, vorname, name, aktiv, strafen) values (</xsl:text>
        <xsl:text>INSERT OR REPLACE INTO team (id, spielnummer, trikotnummer, gast, vorname, name, geburtsjahr, passNr, aktiv, strafen, tore, ausweiskontrolliert, dsr) values (</xsl:text>-->
        <xsl:text>INSERT OR REPLACE INTO team (id, spielId, spielnummer, trikotnummer, gast, vorname, name, aktiv, strafen) values (</xsl:text>
        <xsl:value-of select="@Person_ID"/>
        <xsl:if test="../@teamType = 'Heim'">000</xsl:if>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="../../@ID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="../../@Nummer"/>
        <xsl:text>,"</xsl:text>
        <xsl:value-of select="@TrikotNummer"/>
        <xsl:text>",</xsl:text>
        <xsl:if test="../@teamType = 'Heim'">0</xsl:if>
        <xsl:if test="../@teamType = 'Gast'">1</xsl:if>
        <xsl:text>,"</xsl:text>
        <xsl:value-of select="@Vorname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Name"/>
        <xsl:text>",</xsl:text>
        <xsl:choose>
            <xsl:when test="@Aktiv = 1">1</xsl:when>
            <xsl:when test="@Aktiv != 1">0</xsl:when>
            <xsl:otherwise>1</xsl:otherwise>
        </xsl:choose>
        <xsl:text>,"");</xsl:text>
    </xsl:template>

    <xsl:template match="Person[number(@TrikotNummer) = number(@TrikotNummer) or string-length(@TrikotNummer) = 0]">
        <xsl:text>INSERT OR REPLACE INTO team (id, spielId, spielnummer, trikotnummer, gast, vorname, name, geburtsjahr, passNr, aktiv, strafen, tore, ausweiskontrolliert, dsr) values (</xsl:text>
        <xsl:value-of select="@Person_ID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="../../@ID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="../../@Nummer"/>
        <xsl:text>,</xsl:text>
        <xsl:if test="string-length(@TrikotNummer) = 0">null</xsl:if>
        <xsl:if test="string-length(@TrikotNummer) > 0">
            <xsl:value-of select="@TrikotNummer"/>
        </xsl:if>
        <xsl:text>,</xsl:text>
        <xsl:if test="../@teamType = 'Heim'">0</xsl:if>
        <xsl:if test="../@teamType = 'Gast'">1</xsl:if>
        <xsl:text>,"</xsl:text>
        <xsl:value-of select="@Vorname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Name"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Geburtstag"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Spielerpassnummer"/>
        <xsl:text>",</xsl:text>
        <xsl:choose>
            <xsl:when test="@Aktiv = 1">1</xsl:when>
            <xsl:when test="@Aktiv != 1">0</xsl:when>
            <xsl:otherwise>1</xsl:otherwise>
        </xsl:choose>
        <xsl:text>,"",0,0,0);</xsl:text>
    </xsl:template>

    <xsl:template match="Schiedsrichter/*">
        <xsl:text>INSERT OR REPLACE INTO schiedsrichter (spielId, spielnummer, funktion, vorname, name, pinCheck, adr_nr, schiri_id, verein, wohnort) values (</xsl:text>
        <xsl:value-of select="../../@ID"/>
        <xsl:text>,</xsl:text>
        <xsl:value-of select="../../@Nummer"/>
        <xsl:text>,"</xsl:text>
        <xsl:value-of select="name(.)"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Vorname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@Nachname"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@pinCheck"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@AdrNr"/>
        <xsl:text>","</xsl:text>
        <xsl:value-of select="@id"/>
        <xsl:text>","</xsl:text>
	<xsl:value-of select="@verein"/>
        <xsl:text>","</xsl:text>
	<xsl:value-of select="@wohnort"/>
        <xsl:text>");</xsl:text>
    </xsl:template>

    <xsl:template match="/">
        <!-- xsl:text>Delete existing??;</xsl:text -->
        <xsl:text>CREATE TABLE IF NOT EXISTS spiele (spielId INTEGER, nummer INTEGER, heimId INTEGER, heim TEXT</xsl:text>
        <xsl:text>gastId INTEGER, gast TEXT, datum TEXT, startZeit TEXT, zeit INTEGER, geschlecht TEXT, verband TEXT, staffel TEXT, staffelKurz TEXT, halle TEXT, harzregel TEXT, </xsl:text>
        <xsl:text>pinCheckHeim TEXT, pinCheckGast TEXT, encryptedHeim INTEGER, encryptedGast INTEGER, spielberichtJSON TEXT, timeoutHeim INTEGER, timeoutGast INTEGER, </xsl:text>
        <xsl:text>dauerHalbzeit INTEGER, dauerTimeout INTEGER, dauerHinausstellung INTEGER, anzahlTimeOut INTEGER, anzahlSpieler INTEGER, buzzerNachTimeout INTEGER, buzzerAmEnde INTEGER, pokal INTEGER, sz_datum TEXT,PRIMARY KEY(spielId,nummer));</xsl:text>
        <xsl:apply-templates select="//Spiel"/>
    </xsl:template>

</xsl:stylesheet>
