/* 
 * Configuration Stuff is collected here
 */
if (typeof(me_apps) === 'undefined') {
    me_apps = {};
}
me_apps.VERSION = "3.1";
me_apps.BUILD = "15";
me_apps.UPLOAD_INTERVALL = 300000; // Zeit in ms = 5 Minuten
me_apps.KEEP_REPORTS = 21*24*60*60*1000; // Zeit in ms = 21 Tage
me_apps.DEFAULT_SPIELNUMMER = 0;
me_apps.DEFAULT_SPIELID = 0;
me_apps.IS_TOUCH = (('ontouchstart' in window) || (navigator.msMaxTouchPoints > 0));
me_apps.UPLOAD_DELAY = 5*60;

me_apps.stages = {
    "test" : {
        "URL_PROTOKOLL_SERVER" : "https://test.sbo.handball4all.de/if/ifSbOnline2.php?",
        "URL_IMAGE_SERVER" : "https://test.sbo.handball4all.de/if/ifSbOnline2.php?",
        "MAIN_BACKGROUND" : "#b91616",
        "UPLOAD_DELAY": 10
    },
    "prod" : {
        "URL_PROTOKOLL_SERVER" : "https://sbo.handball4all.de/if/ifSbOnline2.php?",
        "URL_IMAGE_SERVER" : "https://sbo.handball4all.de/if/ifSbOnline2.php?",
        "MAIN_BACKGROUND" : "#0C54A4",
        "UPLOAD_DELAY" : 5*60
    },
    "dev" : {
        "URL_PROTOKOLL_SERVER" : "https://sbodev.h4a.guntram.de/if/ifSbOnline2.php?",
        "URL_IMAGE_SERVER" : "http://sbodev.h4a.guntram.de/if/ifSbOnline2.php?",
        "MAIN_BACKGROUND" : "#0CA454",
        "UPLOAD_DELAY" : 10
    }
};

me_apps.setStage=function(stage) {
    me_apps.log.info('Setting Stage to '+stage);
    me_apps.URL_PROTOKOLL_SERVER = me_apps.stages[stage].URL_PROTOKOLL_SERVER;
    me_apps.URL_IMAGE_SERVER     = me_apps.stages[stage].URL_IMAGE_SERVER;
    me_apps.MAIN_BACKGROUND      = me_apps.stages[stage].MAIN_BACKGROUND;
    me_apps.UPLOAD_DELAY         = me_apps.stages[stage].UPLOAD_DELAY;
    me_apps.STAGE                = stage;
    me_apps.permStorage.stage    = stage;
    $('#Main').css('background-color', me_apps.MAIN_BACKGROUND);
    $('body').css('background-color', me_apps.MAIN_BACKGROUND);
    $('html').css('background-color', me_apps.MAIN_BACKGROUND);
};

me_apps.setStageFromURL = function(url)  {
    // The app version uses prod, unless explicitly set to test.
    if (url.indexOf("android_asset") !== -1) {
        if (me_apps.permStorage && me_apps.permStorage.stage === "test")
            me_apps.setStage("test");
        else
            me_apps.setStage("prod");
    }
    // while the web version depends on where it's loaded from 
    else {
        if (url.indexOf("//sbo.handball4all.de") !== -1)
            me_apps.setStage("prod");
        else if (url.indexOf("h4a.guntram.de") !== -1) 
            me_apps.setStage("dev");
        else
            me_apps.setStage("test");
    }
};

me_apps.getStageAndVersionString = function() {
    return "SBO "+me_apps.STAGE+" Version "+me_apps.VERSION+" v"+me_apps.BUILD;
};

me_apps.LOG = true;
me_apps.V_INTERFACE = "1";
me_apps.gMaxTrikotnumber = 99;
me_apps.loaded = false;
// me_apps.teamloaded = '';
me_apps.currentMatchFinished = true;
me_apps.cnst = {};
me_apps.cnst.send_again = "Nochmals senden";

String.prototype.hashCode = function() {
  var hash = 0, i, chr, len;
  if (this.length === 0) return hash;
  for (i = 0, len = this.length; i < len; i++) {
    chr   = this.charCodeAt(i);
    hash  = ((hash << 5) - hash) + chr;
    hash |= 0; // Convert to 32bit integer
  }
  return hash;
};


me_apps.onlineState= {
    FORCE_OFFLINE : { color: "#ff0000", marker : '—' },
    SENDING:        { color: "#ffff00", marker : 'O' },
    SEND_FAILED:    { color: "#ff8000", marker : 'X' },
    SEND_OK:        { color: "#00ff00", marker : ' ' }
};

me_apps.onlineState.current=        me_apps.onlineState.SEND_OK;
me_apps.onlineState.currentMarker=  me_apps.onlineState.SEND_OK.marker;

me_apps.onlineState.showState =
function() {
    if (me_apps.spiel) {
        me_apps.spiel.onlineStateToGUI(me_apps.onlineState.current, me_apps.onlineState.currentMarker);
    }
};

me_apps.onlineState.setState =
function(state, marker) {
    me_apps.onlineState.current = state;
    if (marker) {
        me_apps.onlineState.currentMarker = marker;
    } else {
        me_apps.onlineState.currentMarker = state.marker;
    }
    this.showState();
};

me_apps.onlineState.isUploadEnabled =
function() {
    return me_apps.onlineState.current !== me_apps.onlineState.FORCE_OFFLINE;
};

me_apps.onlineState.setUploadEnabled =
function(flag) {
    if (flag)
        me_apps.onlineState.setState(me_apps.onlineState.SEND_OK);
    else
        me_apps.onlineState.setState(me_apps.onlineState.FORCE_OFFLINE);
};

