/*
 * Handle dialogs to change team members - player number change, player to
 * officer, officer to player, new player, new officer, ...
 */

if (typeof (me_apps) === 'undefined') {
    me_apps = {};
}

if (typeof (me_apps.obj) === 'undefined') {
    me_apps.obj = {};
}

me_apps.obj.teamMemberDialog = function () {};

/* ***********************************************************
 * Dialoge für Offizielle
 * ***********************************************************/

/* ------------------ change and helper functions --------------------------*/

me_apps.obj.teamMemberDialog.prototype.handleOfficerToSpieler =
function(mannschaft, officer, newNumber) {

    var result=mannschaft.officerRoleChange(officer, newNumber);
    if (result.code === 0) {
        $('#DialogOffiziellerChange').popup('close');
    } else {
        $('#DialogOffiziellerChangeErrors').text(result.text);
    }
};

me_apps.obj.teamMemberDialog.prototype.handleRemoveOfficer =
function(mannschaft, officer) {
    $('#DialogOffiziellerChange').popup('close');
    mannschaft.setMemberInaktiv(officer);
};

me_apps.obj.teamMemberDialog.prototype.showChangeOfficerDialog = 
function(mannschaft, officer) {
    var dialog=this;
    me_apps.spielerDialog.openPopup('#DialogOffiziellerChange');
    $('#ButtonOffiziellerDelete > img').attr("src", "images/list_go.png");
    $('#ButtonOffiziellerDelete > img').attr("alt", "<|-|>");
    $("#DialogOffiziellerChange thead")[0].className = 'Farbe'+mannschaft.selector;
    
    $('#DialogOffiziellerChange input')[0].value = officer.bezeichner;
    $('#DialogOffiziellerChange input')[1].value = officer.vorname;
    $('#DialogOffiziellerChange input')[2].value = officer.name;
    $('#DialogOffiziellerChange input')[3].value = "";

    var guiElem = $('#Offizieller2SpielerGeburtstag');
    if (officer.geburtsjahr !== "" && officer.geburtsjahr !== "00.00.0000") {   // ja das ist das ganze Datum obwohl das Feld Geburtsjahr heißt
        guiElem.prop('readonly', true);
        guiElem.val(officer.geburtsjahr);
        guiElem.addClass("disabled");
    } else {
        guiElem.prop('readonly', false);
        guiElem.val("");
        guiElem.removeClass("disabled");
    }

    var guiElem = $('#Offizieller2SpielerPassNr');
    if (typeof(officer.passNr) !== "undefined" && officer.passNr !== "") {
        guiElem.prop('readonly', true);
        guiElem.val(officer.passNr);
        guiElem.addClass("disabled");
    } else {
        guiElem.prop('readonly', false);
        guiElem.val("");
        guiElem.removeClass("disabled");
    }
    $('#Offizieller2SpielerDSR').prop('checked', officer.DSR).checkboxradio("refresh");
    $('#DialogOffiziellerChangeErrors').text("");

    $('#ButtonOffiziellerChangeToSpieler')[0].onclick = function () {
        dialog.changeOfficerDialogClosedWithPlayerNumber(mannschaft, officer);
    };
    if (me_apps.spiel.zeit === 0) {
        $('#ButtonOffiziellerDelete').show();
        $('#ButtonOffiziellerDelete')[0].onclick = function (event) {
            event.preventDefault();
            event.stopPropagation();
            if ($('#DialogOffiziellerChange input')[3].value) {
                dialog.changeOfficerDialogClosedWithPlayerNumber(mannschaft, officer)
            } else {
                dialog.handleRemoveOfficer(mannschaft, officer);
            }
        };
    } else {
        $('#ButtonOffiziellerDelete').hide();
    }
    
    for (var ascii='A'.charCodeAt(0); ascii<='D'.charCodeAt(0); ascii++) {
        var letter=String.fromCharCode(ascii);
        guiElem=$("#offRenameTo"+letter);
        guiElem.unbind('vclick');
        if (mannschaft.getOffiziellerById(letter) === null) {
            guiElem.bind("vclick", function () {
                dialog.handleOfficerToSpieler(mannschaft, officer, this.innerText.substr(0,1));
            });
            guiElem.removeClass("disabled");
        } else {
            guiElem.addClass("disabled");
        }
    }
};

me_apps.obj.teamMemberDialog.prototype.changeOfficerDialogClosedWithPlayerNumber =
function(mannschaft, officer) {
    officer.passNr = $('#Offizieller2SpielerPassNr').val();
    officer.geburtsjahr = $('#Offizieller2SpielerGeburtstag').val();
    officer.DSR = $('#Offizieller2SpielerDSR').prop('checked');
    this.handleOfficerToSpieler(mannschaft, officer, $('#DialogOffiziellerChange input')[3].value);
};

/* --------------------- add and helper functions --------------------------*/

/**
 * @function handleOfficerAddButtonFromInputs
 * @param {me_apps.obj.mannschaft} mannschaft
 * @param {char} bezeichner
 * @returns {undefined}
 */
me_apps.obj.teamMemberDialog.prototype.handleOfficerAddButtonFromInputs =
function(mannschaft, bezeichner) {
    var inputs = $('#DialogOffiziellerAdd input');
    var spieler = new me_apps.obj.spieler(me_apps.util.getNextId());
    spieler.bezeichner   = inputs[0].value.toUpperCase();
    spieler.vorname      = inputs[1].value;
    spieler.name         = inputs[2].value;
    spieler.geburtsjahr  = inputs[3].value;
    spieler.passNr       = inputs[4].value;
    spieler.DSR          = inputs[5].checked;

    var errors="";
    if (spieler.bezeichner === '')      { errors += ", Bezeichner fehlt"; }
    else if (bezeichner.length !== 1
         || "ABCD".indexOf(spieler.bezeichner) === -1)
                                        { errors += ", Bezeichner "+spieler.bezeichner+" falsch"; }
    else if (mannschaft.getOffiziellerById(spieler.bezeichner))
                                        { errors += ", Offizieller "+spieler.bezeichner+" existiert schon"; }
    if (spieler.vorname==='')           { errors += ", Vorname fehlt"; }
    if (spieler.name==='')              { errors += ", Name fehlt"; }
    //if (spieler.geburtsjahr==='')       { errors += ", Geburtstag fehlt"; }
    //if (spieler.passNr==='')            { errors += ", Passnummer fehlt"; }
    
    if (errors !== '') {
        $('#DialogOffiziellerAddErrors').html(errors.substr(2));
    } else {
        if (mannschaft.encrypted) {
            mannschaft.encrypted=false;
            mannschaft.spieler=[];
            mannschaft.offizielle=[];
            me_apps.db.clearTeamMembers(mannschaft);
        }
        mannschaft.addOfficer(spieler, true);
        this.officersToGUI(mannschaft);
        $('#DialogOffiziellerAdd').popup('close');
    }
};

me_apps.obj.teamMemberDialog.prototype.addOfficerManualInputs = function (bez) {
    var table = $("#DialogOffiziellerAdd tbody");
    var row = "<tr>"
            + "<td><input class='textreadonly' data-mini='true' value='"+bez+"' readonly ></input></td>"
            + "<td><input type='text' data-mini='true' placeholder='Vorname'/></input></td>"
            + "<td><input type='text' data-mini='true' placeholder='Name'/></input></td>"
            + "<td><input type='text' data-mini='true' placeholder='TT.MM.JJJJ'/></td>"
            + "<td><input type='number' data-mini='true' placeholder='PassNr'/></td>"
            + "<td><label><input type='checkbox'/>DSR</label></td>"
            + "</tr>";
    table.append(row);
    table.trigger('create');
};

me_apps.obj.teamMemberDialog.prototype.handleOfficerAddButtonFromList =
function(mannschaft, bezeichner) {
    var error = { code: 0 };
    $("#DialogOffiziellerAdd tbody > tr").each(function (index) {
        if ($(this)[0].className === "rowSelected") {
            var id=$(this)[0].attributes['data-id'].value;
            var spieler=mannschaft.getSpielerById(id);
            error = mannschaft.spielerRoleChange(spieler, bezeichner);
        }
    });
    if (error.code === 0) {
        $('#DialogOffiziellerAdd').popup('close');
    } else {
        $('#DialogOffiziellerAddErrors').html(error.text);
    }
};

me_apps.obj.teamMemberDialog.prototype.switchAddOfficerDialogToManual =
function(mannschaft, bezeichner) {
    var dialog=this;
    $("#DialogOffiziellerAdd tbody tr").remove();
    me_apps.teamMemberDialog.addOfficerManualInputs(bezeichner);        
    $('#DialogOffiziellerAdd input')[0].value = bezeichner;
    $('#OpenButtonAddOffizieller').hide();
    $('#ButtonOffiziellerAdd')[0].onclick = function() {
        dialog.handleOfficerAddButtonFromInputs(mannschaft, bezeichner);
    };
};

me_apps.obj.teamMemberDialog.prototype.switchAddOfficerDialogToList =
function(mannschaft, bezeichner) {
    var dialog=this;
    $("#DialogOffiziellerAdd tbody tr").remove();
    this.addInaktiveSpielerToOffiziellerDialog(mannschaft, bezeichner);
    $('#OpenButtonAddOffizieller').show();
    $('#OpenButtonAddOffizieller').unbind('vclick').bind('vclick', function() {
        dialog.switchAddOfficerDialogToManual(mannschaft, bezeichner);
    });
    $('#ButtonOffiziellerAdd')[0].onclick = function() {
        dialog.handleOfficerAddButtonFromList(mannschaft, bezeichner);
    };
};

me_apps.obj.teamMemberDialog.prototype.showAddOfficerDialog =
function(mannschaft, bezeichner) {
    var dialog=this;
    
    if (me_apps.spiel.zeit > 0 && mannschaft.quotaOfficer <= 0) {
        me_apps.spielerDialog.openPopup('#DialogTeamMemberAddQuotaReached');
        return;
    }
    me_apps.spielerDialog.openPopup('#DialogOffiziellerAdd');
    $('#OpenButtonAddOffizieller').button();
    $('#ButtonOffiziellerAdd > img').attr("src", "images/list_add.png");
    $('#ButtonOffiziellerAdd > img').attr("alt", "<|+|>");
    $("#DialogOffiziellerAdd thead")[0].className = 'Farbe'+mannschaft.selector;
    $('#DialogOffiziellerAddErrors').html('');
    $('#DialogOffiziellerAddQuota').html(me_apps.spiel.zeit > 0 ? "(noch "+mannschaft.quotaOfficer+")" : "");

    if (mannschaft.inaktiveSpieler().length > 0) {
        dialog.switchAddOfficerDialogToList(mannschaft, bezeichner);
    } else {
        dialog.switchAddOfficerDialogToManual(mannschaft, bezeichner);        
    }
};

me_apps.obj.teamMemberDialog.prototype.addInaktiveSpielerToOffiziellerDialog = function (mannschaft, bez) {
    $("#DialogOffiziellerAdd thead")[0].className = (mannschaft.selector === "heim") ? "Farbeheim" : "Farbegast";
    $("#DialogOffiziellerAdd tbody tr").remove();
    var table = $("#DialogOffiziellerAdd tbody");
    if (mannschaft.encrypted) {
       table.append("<tr><td colspan=6 style='text-align:center; color:#ff0000;'>Mannschaft muss erst entschlüsselt werden</td></tr>");
       $("#OpenButtonAddOffiziellerWarning").show();
    } else {
        mannschaft.inaktiveSpieler().forEach(function (spieler) {
            var row = "<tr data-id=\""+spieler.id+"\">"
                    + "<td>" + ((spieler.bezeichner !== null) ? spieler.bezeichner : '') + "</td>"
                    + "<td>" + spieler.vorname + "</td>"
                    + "<td>" + spieler.name + "</td>"
                    + "<td>" + spieler.geburtsjahr + "</td>"
                    + "<td>" + spieler.passNr + "</td>"
                    + "<td>" + ((spieler.DSR) ? "ja" : "nein") + "</td>"
                    + "</tr>";
            table.append(row);
        });
        $("#OpenButtonAddOffiziellerWarning").hide();
    }
    table.trigger('create');
    $("#DialogOffiziellerAdd tbody tr").unbind("click").bind("click", me_apps.obj.mannschaft.selectRow);
};

me_apps.obj.teamMemberDialog.prototype.officersToGUI =
function(mannschaft) {
    me_apps.log.logCall();
    var rowSelector = '#Spieler' + mannschaft.selector + ' > table > tbody > tr';
    for (var i = 0; i < 4; i++) {
        var row = $(rowSelector)[i];
        var bez = String.fromCharCode(65 + i);
        var currOff = mannschaft.getSpieler(bez);
        if (currOff !== null) {
            row.id = 'Spieler' + mannschaft.selector + currOff.bezeichner;
            row.children[0].innerHTML = currOff.bezeichner;
            row.children[0].className = currOff.aktiv ? "" : "ui-disabled";
            row.children[1].innerHTML = currOff.tore;
            row.children[2].innerHTML = currOff.getDisciplineString();
            row.setAttribute("data-id", currOff.bezeichner);
            if (currOff.aktiv) {
                row.children[3].innerHTML = currOff.name + "," + currOff.vorname;
            } else {
                row.children[3].innerHTML = "";
            }
            row.children[2].innerHTML = currOff.getDisciplineString();
        } else {
            if (i === 0 ) {
                        row.children[0].className = "ohneNummer";
            }
            else {
                        row.children[0].className = "ui-disabled";
            }
            row.id = 'Spieler' + mannschaft.selector + String.fromCharCode(65 + i);
            row.children[0].innerHTML = String.fromCharCode(65 + i);
            row.children[1].innerHTML = "";
            row.children[2].innerHTML = "";
            row.children[3].innerHTML = "";
        }
    }
};

/* ***********************************************************
 * Dialoge für Spieler
 * ***********************************************************/

/* ------------------ change and helper functions --------------------------*/

me_apps.obj.teamMemberDialog.prototype.handleChangeSpielerBezeichner =
function(mannschaft, spieler, newBezeichner) {
    me_apps.log.logCall();
    me_apps.log.debug("handleChangeSpielerBezeichner: newBezeichner='"+newBezeichner+"'");
    var result=mannschaft.spielerRoleChange(spieler, newBezeichner);
    if (result.code === 0) {
        $("#DialogSpielerChange").popup("close");
    } else {
        $("#DialogSpielerChangeErrors").html(result.text);
    }
};

me_apps.obj.teamMemberDialog.prototype.handleRemoveSpieler =
function(mannschaft, spieler) {
    $("#DialogSpielerChange").popup("close");    
    mannschaft.setMemberInaktiv(spieler);
};

me_apps.obj.teamMemberDialog.prototype.showChangeSpielerDialog = 
function(mannschaft, spieler) {
    var dialog=this;
    me_apps.spielerDialog.openPopup('#DialogSpielerChange');
    $("#DialogSpielerChange thead").className = 'Farbe'+mannschaft.selector;
    $('#DialogSpielerChangeName').text(spieler.vorname + " " + spieler.name);
    $('#DialogSpielerChangeNr').text( spieler.bezeichner);
    
    $('#DialogSpielerChange input')[0].value = spieler.bezeichner;
    // Die zwei kann man in der GUI nicht ändern ...
    // $('#DialogSpielerChange input')[1].value = spieler.vorname;
    // $('#DialogSpielerChange input')[2].value = spieler.name;

    $('#ButtonSpielerChange').unbind("vclick").bind("vclick", function () {
        dialog.handleChangeSpielerBezeichner(mannschaft, spieler,
            $('#DialogSpielerChange input')[0].value);
    });
    if (me_apps.spiel.zeit===0) {
        $('#ButtonSpielerDelete').show();
        $('#ButtonSpielerDelete').unbind("vclick").bind("vclick", function () {
            dialog.handleRemoveSpieler(mannschaft, spieler);
        });
    } else {
        $('#ButtonSpielerDelete').hide();
    }
    
    var anyOfficersEmpty=false;
    for (var ascii='A'.charCodeAt(0); ascii<='D'.charCodeAt(0); ascii++) {
        var letter=String.fromCharCode(ascii);
        var guiElem=$("#off"+letter);
        guiElem.unbind('vclick');
        if (mannschaft.getOffiziellerById(letter) === null) {
            guiElem.bind("vclick", function () {
                dialog.handleChangeSpielerBezeichner(mannschaft, spieler, this.innerText.substr(0,1));
            });
            guiElem.removeClass("disabled");
            anyOfficersEmpty=true;
        } else {
            guiElem.addClass("disabled");
        }
    }
    if (anyOfficersEmpty) {
        $('#msg_official').hide();
        $('.ButtonChangeToOffizieller').show();
    } else {
        $('#msg_official').show();
        $('.ButtonChangeToOffizieller').hide();
    }
    $('#DialogSpielerChangeErrors').html('');
};

/* --------------------- add and helper functions --------------------------*/

me_apps.obj.teamMemberDialog.prototype.playerDuplicate =
function(playerA, playerB) {
    if (playerA.passNr !== playerB.passNr)
        return false;
    // Zusatzcheck auf Name, Vorname, Geb.-Datum, ... ?
    return true;
};

/**
 * @function handleSpielerAddButtonFromInputs
 * @param {me_apps.obj.mannschaft} mannschaft
 * @param {char} bezeichner
 * @returns {undefined}
 */
me_apps.obj.teamMemberDialog.prototype.handleSpielerAddButtonFromInputs =
function(mannschaft, bezeichner) {
    var inputs = $('#DialogSpielerAdd input');
    var spieler = new me_apps.obj.spieler(me_apps.util.getNextId());
    spieler.bezeichner   = inputs[0].value;
    spieler.vorname      = inputs[1].value;
    spieler.name         = inputs[2].value;
    spieler.geburtsjahr  = inputs[3].value;
    spieler.passNr       = inputs[4].value;
    spieler.DSR          = inputs[5].checked;
    var errors="";
    var passError = false;
    if (spieler.bezeichner === '')      { errors += ", Nummer fehlt"; }
    else if (isNaN(spieler.bezeichner)) { errors += ", "+spieler.bezeichner+" ist keine Zahl"; }
    else if (spieler.bezeichner <= 0 || spieler.bezeichner > me_apps.gMaxTrikotnumber)
                                        { errors += ", "+spieler.bezeichner+" ist keine gültige Trikotnummer"; }
    else if (mannschaft.getSpielerWithTrikotNr(spieler.bezeichner))
                                        { errors += ", Spieler "+spieler.bezeichner+" existiert schon"; }
    if (spieler.vorname==='')           { errors += ", Vorname fehlt"; }
    if (spieler.name==='')              { errors += ", Name fehlt"; }
    if (spieler.geburtsjahr==='')       { errors += ", Geburtstag fehlt"; }
    else if (!me_apps.util.validateDDMMYYYY(spieler.geburtsjahr)) { errors += ", Datumsformat muss TT.MM.JJJJ sein"; }
    if (spieler.passNr==='')            { errors += ", Passnummer fehlt"; passError = true;}
    
    if (!passError && !spieler.passNr.match(/^\d+$/)) {
        errors += ", "+me_apps.obj.mannschaft.errcodes.PASS_NUMBER_INVAL.text;
        passError = true;
    }

    if (!passError && spieler.passNr !== "0000") {    // #980 - Passnummer 0000 darf mehrmals verwendet werden
        for (var i=0; i<mannschaft.spieler.length; i++) {
            if (this.playerDuplicate(mannschaft.spieler[i], spieler)) {
                errors += ", Passnummer "+spieler.passNr+" schon als "+mannschaft.spieler[i].vorname+" "+mannschaft.spieler[i].name+" vorhanden";
                break;
            }
        }
    }

    
    if (errors !== '') {
        $('#DialogSpielerAddErrors').html(errors.substr(2));
    } else {
        if (mannschaft.encrypted) {
            mannschaft.encrypted=false;
            mannschaft.spieler=[];
            mannschaft.offizielle=[];
            me_apps.db.clearTeamMembers(mannschaft);
        }
        mannschaft.addSpieler(spieler, true);
        $('#DialogSpielerAdd').popup('close');
    }
};

me_apps.obj.teamMemberDialog.prototype.addSpielerManualInputs = function () {
    var table = $("#DialogSpielerAdd tbody");
    var row = "<tr>"
            + "<td><input type='text' data-mini='true' value=''  ></input></td>"
            + "<td><input type='text' data-mini='true' placeholder='Vorname'/></input></td>"
            + "<td><input type='text' data-mini='true' placeholder='Name'/></input></td>"
            + "<td><input type='text' data-mini='true' placeholder='TT.MM.JJJJ'/></td>"
            + "<td><input type='number' data-mini='true' placeholder='PassNr'/></td>"
            + "<td><label><input type='checkbox'/>DSR</label></td>"
            + "</tr>";
    table.append(row);
    table.trigger('create');
};

/**
 * 
 * @param {me_apps.obj.mannschaft} mannschaft
 * @param {integer} bezeichner Trikotnummer
 * @returns {undefined}
 */
me_apps.obj.teamMemberDialog.prototype.handleSpielerAddButtonFromList =
function(mannschaft, bezeichner) {
    var newShirtNumber={};
    var errors='';
    var usedNewNumbers = {};
    $("#DialogSpielerAdd tbody > tr").each(function (index) {
        var cell = $(this).children('td').first();
        cell.removeClass("ungültigeEingabe");
        if ($(this)[0].className === "rowSelected") {
            var playerId=$(this)[0].attributes['data-id'].value;
            var inputs = $(this).find('input');
            var newNumber=inputs[0].value;
            if (isNaN(newNumber) || newNumber<1 || newNumber>me_apps.gMaxTrikotnumber) {
                cell.addClass("ungültigeEingabe");
                errors+=", fehlerhafte Nummer";
            } else if (mannschaft.getSpielerWithTrikotNr(newNumber)) {
                cell.addClass("ungültigeEingabe");
                errors+=", Trikotnummer "+newNumber+ " existiert schon";
            } else if (usedNewNumbers["x"+newNumber]) {
                cell.addClass("ungültigeEingabe");
                errors+=", doppelte Nummer "+newNumber;
            } else {
                newShirtNumber[playerId]=newNumber;
            }
            usedNewNumbers["x"+newNumber]=true;
        }
        return true;
    });

    for (var playerId in newShirtNumber) {
        if (errors !== '')
            break;
        var status=mannschaft.setMemberActive(playerId, newShirtNumber[playerId]);
        if (status !== me_apps.obj.mannschaft.errcodes.OK)
            errors=status.text;
    }

    if (errors === '') {
        $('#DialogSpielerAdd').popup('close');
    } else {
        $('#DialogSpielerAddErrors').html(errors.substr(2));
    }
};

me_apps.obj.teamMemberDialog.prototype.switchAddSpielerDialogToManual =
function(mannschaft, bezeichner) {
    var dialog=this;
    $("#DialogSpielerAdd tbody tr").remove();
    me_apps.teamMemberDialog.addSpielerManualInputs(bezeichner);        
    $('#DialogSpielerAdd input')[0].value = bezeichner;
    $('#OpenButtonAddSpieler').hide();
    $('#ButtonSpielerAdd')[0].onclick = function() {
        dialog.handleSpielerAddButtonFromInputs(mannschaft, bezeichner);
    };
};

me_apps.obj.teamMemberDialog.prototype.switchAddSpielerDialogToList =
function(mannschaft, bezeichner) {
    var dialog=this;
    $("#DialogSpielerAdd tbody tr").remove();
    this.addInaktiveSpielerToSpielerDialog(mannschaft, bezeichner);
    $('#OpenButtonAddSpieler').show();
    $('#OpenButtonAddSpieler').unbind('vclick').bind('vclick', function() {
        dialog.switchAddSpielerDialogToManual(mannschaft, bezeichner);
    });
    $('#ButtonSpielerAdd')[0].onclick = function() {
        dialog.handleSpielerAddButtonFromList(mannschaft, bezeichner);
    };
};

me_apps.obj.teamMemberDialog.prototype.showAddSpielerDialog =
function(mannschaft, bezeichner) {
    var dialog=this;
    
    if (me_apps.spiel.zeit > 0 && mannschaft.quotaPlayer <= 0) {
        me_apps.spielerDialog.openPopup('#DialogTeamMemberAddQuotaReached');
        return;
    }    
    me_apps.spielerDialog.openPopup('#DialogSpielerAdd');
    $('#OpenButtonAddSpieler').button();
    $('#ButtonSpielerAdd > img').attr("src", "images/list_add.png");
    $('#ButtonSpielerAdd > img').attr("alt", "<|+|>");
    $("#DialogSpielerAdd thead")[0].className = 'Farbe'+mannschaft.selector;
    $('#DialogSpielerAddErrors').html('');
    $('#DialogSpielerAddQuota').html(me_apps.spiel.zeit > 0 ? "(noch "+mannschaft.quotaPlayer+")" : "");    

    if (mannschaft.inaktiveSpieler().length > 0) {
        dialog.switchAddSpielerDialogToList(mannschaft, bezeichner);
    } else {
        dialog.switchAddSpielerDialogToManual(mannschaft, bezeichner);        
    }
};

me_apps.obj.teamMemberDialog.prototype.addInaktiveSpielerToSpielerDialog = function (mannschaft, bez) {
    $("#DialogSpielerAdd thead")[0].className = (mannschaft.selector === "heim") ? "Farbeheim" : "Farbegast";
    $("#DialogSpielerAdd tbody tr").remove();
    var table = $("#DialogSpielerAdd tbody");
    if (mannschaft.encrypted) {
       table.append("<tr><td colspan=6 style='text-align:center; color:#ff0000;'>Mannschaft muss erst entschlüsselt werden</td></tr>");
       $("#OpenButtonAddSpielerWarning").show();
    } else {
        mannschaft.inaktiveSpieler().forEach(function (spieler) {
            var row = "<tr data-id=\""+spieler.id+"\">"
                    + "<td>"
                    +"<input type='number' step='1' min='1' max='99' style='width:4em' data-mini='true' placeholder='T-Nr.'></input>"
                    +"</td>"
                    + "<td>" + spieler.vorname + "</td>"
                    + "<td>" + spieler.name + "</td>"
                    + "<td>" + spieler.geburtsjahr + "</td>"
                    + "<td>" + spieler.passNr + "</td>"
                    + "<td>" + ((spieler.DSR) ? "ja" : "nein") + "</td>"
                    + "</tr>";
            table.append(row);
        });
        $("#OpenButtonAddSpielerWarning").hide();
    }
    table.trigger('create');
    $("#DialogSpielerAdd tbody tr").unbind("click").bind("click", me_apps.obj.mannschaft.selectRow);
};

me_apps.obj.teamMemberDialog.prototype.spielerToGUI = 
function(mannschaft) {
    me_apps.log.logCall();
    var aktiveSpieler = mannschaft.aktiveSpieler();
    var table = $('#Spieler' + mannschaft.selector + '>div:first-child >table>tbody');
    var noOfRows = aktiveSpieler.length + 1;
    noOfRows = (noOfRows < 16) ? 16 : noOfRows;
    var html = "";
    for (var i = 0; i < noOfRows; i++) {
        if (i >= me_apps.spiel.anzahlSpieler) {
            html += "<tr class='UeberzaehligeSpieler'><td>&#160;</td><td>&#160;</td><td>&#160;</td><td>&#160;</td></tr>";
        } else {
            html += "<tr><td>&#160;</td><td>&#160;</td><td>&#160;</td><td>&#160;</td></tr>";
        }
    }
    table.html(html);
    table.trigger('create');
    var rows = $('#Spieler' + mannschaft.selector + '>div:first-child >table>tbody>tr');
    me_apps.log.debug('updateSpieler before rows ' + rows);
    for (var i = 0; i < aktiveSpieler.length; i++) {
        var row = rows[i];
        row.id = 'Spieler' + mannschaft.selector + aktiveSpieler[i].id;
        row.children[0].innerHTML = (aktiveSpieler[i].bezeichner === "") ? '?' : aktiveSpieler[i].bezeichner;
        row.setAttribute("data-id", aktiveSpieler[i].id);
        var isProblem = aktiveSpieler[i].bezeichner === "";
        for (var j=0; !isProblem && j<aktiveSpieler.length; j++) {
            if (i !== j && aktiveSpieler[i].bezeichner === aktiveSpieler[j].bezeichner) {
                isProblem = true;
            }
        }
            
        if (isProblem) {
            row.children[0].setAttribute("class", "ohneNummer");
        } else {
            row.children[0].removeAttribute("class", "ohneNummer");
        }
        if (aktiveSpieler[i].id < 0) {
            rows.slice(i, i + 1).addClass("manuellHinzugefuegt");
        } else {
            rows.slice(i, i + 1).removeClass("manuellHinzugefuegt");
        }
        row.children[1].innerHTML = aktiveSpieler[i].tore;
        if (me_apps.spiel.zeit === 0) {
            me_apps.obj.mannschaft.changeAnzeigeNamenStrafen('heim', 'Name');
        	me_apps.obj.mannschaft.changeAnzeigeNamenStrafen('gast', 'Name');
        } else {
            me_apps.obj.mannschaft.changeAnzeigeNamenStrafen('heim', 'Strafen');
        	me_apps.obj.mannschaft.changeAnzeigeNamenStrafen('gast', 'Strafen');
        }
        row.children[3].innerHTML = aktiveSpieler[i].name + "," + aktiveSpieler[i].vorname;
        row.children[2].innerHTML = aktiveSpieler[i].getDisciplineString();
    }
    me_apps.log.debug('updateSpieler after rows' + rows);
};
